Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Member Functions | Public Attributes | List of all members
faiss::IndexRefineFlat Struct Reference

`#include <IndexFlat.h>`

Inheritance diagram for faiss::IndexRefineFlat:

## Public Member Functions
| IndexRefineFlat (Index *base_index)
virtual void | train (idx_t n, const float *x) override
virtual void | add (idx_t n, const float *x) override
virtual void | reset () override
| removes all elements from the database.
virtual void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
virtual void | set_typename () override
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_INNER_PRODUCT)
virtual void | add_with_ids (idx_t n, const float *x, const long *xids)
virtual void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual long | remove_ids (const IDSelector &sel)
virtual void | reconstruct (idx_t key, float *recons) const
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const
virtual std::string | get_typename () const

## Public Attributes
IndexFlat | refine_index
| storage for full vectors
Index * | base_index
| faster index to pre-select the vectors that should be filtered
bool | own_fields
| should the base index be deallocated?
float | k_factor
Public Attributes inherited from faiss::Index
std::string | index_typename
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Additional Inherited Members
Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type

## Detailed Description

Index that queries in a base_index (a fast one) and refines the results with an exact search, hopefully improving the results.

Definition at line 105 of file IndexFlat.h.

## Member Function Documentation

void faiss::IndexRefineFlat::add | ( | idx_t | n,
|  | const float * | x
| ) |  |
| override virtual

Add n vectors of dimension d to the index.

Vectors are implicitly assigned labels ntotal .. ntotal + n - 1 This function slices the input vectors in chuncks smaller than blocksize_add and calls add_core.

Parameters

  x | input matrix, size n * d

Implements faiss::Index.

Definition at line 177 of file IndexFlat.cpp.

void faiss::IndexRefineFlat::search | ( | idx_t | n,
|  | const float * | x,
|  | idx_t | k,
|  | float * | distances,
|  | idx_t * | labels
| ) |  | const
| override virtual

query n vectors of dimension d to the index.

return at most k vectors. If there are not enough results for a query, the result array is padded with -1s.

Parameters

  x | input vectors to search, size n * d
  labels | output labels of the NNs, size n*k
  distances | output pairwise distances, size n*k

Implements faiss::Index.

Definition at line 219 of file IndexFlat.cpp.

void faiss::IndexRefineFlat::train | ( | idx_t | n,
|  | const float * | x
| ) |  |
| override virtual

Perform training on a representative set of vectors

Parameters

  n | nb of training vectors
  x | training vecors, size n * d

Reimplemented from faiss::Index.

Definition at line 171 of file IndexFlat.cpp.

## Member Data Documentation

float faiss::IndexRefineFlat::k_factor

factor between k requested in search and the k requested from the base_index (should be >= 1)

Definition at line 116 of file IndexFlat.h.

The documentation for this struct was generated from the following files:

- IndexFlat.h
- IndexFlat.cpp